<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Attributes\Appends;
use Illuminate\Database\Eloquent\Attributes\Guarded;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\MorphTo;

#[Appends(['formatted_quantity', 'formatted_stock_after', 'formatted_stock_before'])]
#[Guarded(['id'])]
class StockMutation extends Model
{
    use HasFactory;

    protected function casts(): array
    {
        return [
            'quantity' => 'integer',
            'stock_before' => 'integer',
            'stock_after' => 'integer',
        ];
    }

    protected function formattedQuantity(): Attribute
    {
        return Attribute::make(
            get: fn () => number_format($this->quantity, 0, ',', '.'),
        );
    }

    protected function formattedStockAfter(): Attribute
    {
        return Attribute::make(
            get: fn () => number_format($this->stock_after, 0, ',', '.'),
        );
    }

    protected function formattedStockBefore(): Attribute
    {
        return Attribute::make(
            get: fn () => number_format($this->stock_before, 0, ',', '.'),
        );
    }

    public function source(): MorphTo
    {
        return $this->morphTo();
    }

    public function stockable(): MorphTo
    {
        return $this->morphTo();
    }

    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }
}
